//Renan Mathias Fernandes 02513356
//cesar henrique kallas 02099224
package openchat.bd;

import java.sql.*;
import java.util.*;


public class BancoDados
{
	private java.sql.Connection conexao;
	private Statement comando;
	private ResultSet Resultado, ResultFlag;
	private String local ="";
	private String Host;
	private int Port;
		
	public BancoDados(String Host, int porta) 
	{
		try
		{
			Class.forName("com.mysql.jdbc.Driver").newInstance();
			this.Host = Host;
			this.Port = porta;
		}
		catch(Exception E) {
			System.out.print("Erro no driver\n");
			System.out.println(E.getMessage());
		} 
	
		try {
			conexao = DriverManager.getConnection("jdbc:mysql://"+Host+":"+porta+"/si20304_bd?user=si20304&password=Dh0iy2");
		}
		catch (SQLException ex) {
		
			System.out.println("SQLException: " + ex.getMessage());
			System.out.println("SQLState: " + ex.getSQLState());
			System.out.println("VendorError: " + ex.getErrorCode());
		}


		try
		{
			 comando = conexao.createStatement();
		}
		
		catch(SQLException B)
		{
			System.out.println("Impossivel criar comando");
		}
	}
	
	public static void main(String args[])
	{
	}
	
	public boolean UserLogin(int Id, String Pass, String Ip, int porta)
	{
		boolean Resul=false;
		if(TestUserIdent(Id,Pass))
		if(ReturnUserIp(Id).equals("0"))
		{
			try
			{
				comando.executeUpdate("Update usuarios SET ip=\'"+Ip+"\',porta=\'"+porta+"\' WHERE id=\'"+Id+"\' ");
				Resul=true;
			}
			catch(SQLException E)
			{
				System.out.println("erro login");
			}
		}
		return Resul;
		
	}
	
	public boolean UserLogout(int Id, String Pass)
	{
		boolean Resul=false;
		
		if(TestUserIdent(Id,Pass))	//if user and pass is correct
		if(!ReturnUserIp(Id).equals("0"))	//if user is logged
		{
			try
			{
				comando.executeUpdate("Update usuarios SET ip='0',porta='0' WHERE id=\'"+Id+"\' ");
				Resul=true;
			}
			catch(SQLException E)
			{
				System.out.println("erro logout");
			}
		}
		return Resul;
	}
	
	/*	
	public boolean CreatUserColumn(int Id)
	{
		String nome = "_"+Id;
		boolean Resul=false;
		
		try
		{
			comando.executeUpdate("ALTER TABLE contatos ADD COLUMN "+nome+" int(100) not null");
			Resul=true;
		}
		catch(SQLException E)
		{
			System.out.println("erro criar coluna");
			System.out.println(E.getMessage());
		}
		return Resul;
	}
	
	public boolean DeleteUserColumn(int Id)
	{
		String nome = "_"+Id;
		boolean Resul=false;
				
		try
		{
			comando.executeUpdate("ALTER TABLE contatos DROP COLUMN "+nome+"");
			Resul=true;
		}
		catch(SQLException E)
		{
			System.out.println("erro criar coluna");
			System.out.println(E.getMessage());
		}
		return Resul;
	}
	*/
	
	public int NewUser(String NewLogin, String NewEmail, String nome, String senha, String cidade, String Info)
	{
		Random rand = new Random();
		int id=0;
		
		while(true)
		{
			id = rand.nextInt(Qtusuarios()+10000);
			if(id<1000)
				id=id+1000;
			if(!ExistUser(id))
				break;
		}
		
		try
		{
			comando.executeUpdate("INSERT INTO usuarios(login,email,nome,id,senha,info,cidade,ip,porta) values(\'"+NewLogin+"\',\'"+NewEmail+"\',\'"+nome+"\',\'"+id+"\',\'"+senha+"\',\'"+Info+"\',\'" +cidade+"\','0','0')");
			//CreatUserColumn(id);
		
		}
		catch(SQLException E)
		{
			System.out.println("Erro em inserrir");
			id=0;
		}
		return id;
	}
	
	public boolean DeleteUser (int ident, String pass)
	{
		boolean result=false;
		
		if(TestUserIdent(ident,pass))
		{
			try
			{
				comando.executeUpdate("DELETE FROM usuarios WHERE id= \'"+ident+"\' AND senha=\'"+pass+"\'");
				//DeleteUserColumn(ident);
				result=true;
			}
			catch(SQLException E)
			{
				System.out.println("Erro em pagar id");
			}
		}
		return result;
	}
	
	public boolean UpdateUser(int Id, String Login, String Email, String nome, String senha, String cidade, String Info)
	{
		boolean result=false;
		//if(TestUserIdent(Id,senha))
		{
			try
			{
				comando.executeUpdate("Update usuarios SET login=\'"+Login+"\',email=\'"+Email+"\',nome=\'"+nome+"\',senha=\'"+senha+"\',info=\'"+Info+"\',cidade=\'"+cidade+"\' WHERE id=\'"+Id+"\' ");
				result=true;
			}
			catch(SQLException E)
			{
				System.out.println("erro em atualizar");
			}
		}
		return result;
	}
	
	public String ReturnUserLogin(int ident)
	{
		try
		{
			Resultado = comando.executeQuery("SELECT id,login FROM usuarios WHERE id= \'"+ident+"\'");
			Resultado.first();
		}
		catch(SQLException E)
		{
			System.out.println("Erro ao logar");
		}
		
		try
		{
			local = Resultado.getString("login");
		}
		catch(SQLException D)
		{
			System.out.println("Impossivel ver coluna");
	
		}
		return local;
	}
	
	public String ReturnUserIp(int ident)
	{
		try
		{
			Resultado = comando.executeQuery("SELECT id,ip FROM usuarios WHERE id= \'"+ident+"\'");
			Resultado.first();
		}
		catch(SQLException E)
		{
			System.out.println("Erro ao logar");
		}
		
		try
		{
			local = Resultado.getString("ip");
		}
		catch(SQLException D)
		{
			System.out.println("Impossivel ver coluna");
	
		}
		return local;
	}
	
	
	public int ReturnUserPort(int ident)
	{
		int porta=0;
		try
		{
			Resultado = comando.executeQuery("SELECT id,porta FROM usuarios WHERE id= \'"+ident+"\'");
			Resultado.first();
		}
		catch(SQLException E)
		{
			System.out.println("Erro ao logar");
		}
		
		try
		{
			porta = Resultado.getInt("porta");
		}
		catch(SQLException D)
		{
			System.out.println("Impossivel ver coluna");
	
		}
		return porta;
	}
	
	
	public String ReturnUserName(int ident)
	{
		try
		{
			Resultado = comando.executeQuery("SELECT id,nome FROM usuarios WHERE id= \'"+ident+"\'");
			Resultado.first();
		}
		catch(SQLException E)
		{
			System.out.println("Erro ao logar");
		}
		
		try
		{
			local = Resultado.getString("nome");
		}
		catch(SQLException D)
		{
			System.out.println("Impossivel ver coluna");
	
		}
		return local;
	}
	
	public String ReturnUserEmail(int ident)
	{
		try
		{
			Resultado = comando.executeQuery("SELECT id,email FROM usuarios WHERE id= \'"+ident+"\'");
			Resultado.first();
		}
		catch(SQLException E)
		{
			System.out.println("Erro ao logar");
		}
		
		try
		{
			local = Resultado.getString("email");
		}
		catch(SQLException D)
		{
			System.out.println("Impossivel ver coluna");
	
		}
		return local;
	}
	
	public String ReturnUserInfo(int ident)
	{
		try
		{
			Resultado = comando.executeQuery("SELECT id,info FROM usuarios WHERE id= \'"+ident+"\'");
			Resultado.first();
		}
		catch(SQLException E)
		{
			System.out.println("Erro ao logar");
		}
		
		try
		{
			local = Resultado.getString("info");
		}
		catch(SQLException D)
		{
			System.out.println("Impossivel ver coluna");
	
		}
		return local;
	}
	
	public String ReturnUserCity(int ident)
	{
		try
		{
			Resultado = comando.executeQuery("SELECT id,cidade FROM usuarios WHERE id= \'"+ident+"\'");
			Resultado.first();
		}
		catch(SQLException E)
		{
			System.out.println("Erro ao logar");
		}
		
		try
		{
			local = Resultado.getString("cidade");
		}
		catch(SQLException D)
		{
			System.out.println("Impossivel ver coluna");
	
		}
		return local;
	}
	
	public String ReturnUserId(String Email)
	{
		try
		{
			Resultado = comando.executeQuery("SELECT id,email FROM usuarios WHERE email= \'"+Email+"\'");
			Resultado.first();
		}
		catch(SQLException E)
		{
			System.out.println("Erro ao logar");
		}
		
		try
		{
			local = Resultado.getString("id");
		}
		catch(SQLException D)
		{
			System.out.println("Impossivel ver coluna");
	
		}
		return local;
	}
	
	public boolean TestUserIdent(int ident, String pass)
	{
		try
		{
			Resultado = comando.executeQuery("SELECT count(*) as OK FROM usuarios WHERE id= \'"+ident+"\' AND senha=\'"+pass+"\'");
			Resultado.first();
		}
		catch(SQLException E)
		{
			System.out.println("Erro ao logar");
		}
		
		
		boolean Confirm=false;
		
		try
		{
			Confirm = Resultado.getInt("OK") != 0;
		}
		catch (SQLException E)
		{
			System.out.println("Erro em ExistUser");
		}
		return Confirm;
	}
	
	public int Qtusuarios()
	{
		int T=0;
		
		try
		{
			Resultado = comando.executeQuery("SELECT count(*) as Qtde FROM usuarios");
		}
		
		catch(SQLException New)
		{
			System.out.println("Erro Allusuarios");
		}
		
		try
		{
			Resultado.first();
		}
		catch(SQLException E)
		{
			System.out.println("Erro allusuarios");
		}
				
		try
		{
			T = Resultado.getInt("Qtde");
		}
		catch (SQLException E)
		{
			System.out.println("Erro em ExistUser");
		}
		return T;
	}
		
	public boolean ExistUser(int ident)
	{
		try
		{
			Resultado = comando.executeQuery("SELECT count(*) as Exist FROM usuarios WHERE id= \'"+ident+"\'");
		}
		
		catch(SQLException New)
		{
			System.out.println("Erro exist usuario");
		}
				
		try
		{
			Resultado.first();
		}
		catch(SQLException E)
		{
			System.out.println("Erro exist user first");
		}
		
		boolean Exist=false;
		
		try
		{
			Exist = Resultado.getInt("Exist") != 0;
		}
		catch (SQLException E)
		{
			System.out.println("Erro em ExistUser");
		}
		return Exist;
	}
	
	public boolean AddUserContact(int Id, int contato)
	{
		boolean Resul=false;
		
		if(ExistUser(Id))
		if(ExistUser(contato))
		if(!ExistContactUser(Id,contato))
		{
			try
			{
				String Ident = "_"+Id;
				comando.executeUpdate("INSERT INTO contatos(id,contato) values(\'"+Id+"\',\'"+contato+"\')");
				Resul=true;
			}
			catch(SQLException E)
			{
				System.out.println("Erro ao cadastrar contato");
				System.out.println(E.getMessage());
			}
		}
		//else
		//	System.out.print("ja existe usuario na lista");
		//else
		//	System.out.print("exist user ?");
		
		return Resul;
	}
		
	public boolean DeleteUserContact(int Id, int contato)
	{
		boolean Resul=false;
		
		if(ExistUser(Id))
		if(ExistContactUser(Id,contato))
		{
			try
			{
				String Ident = "_"+Id;
				comando.executeUpdate("DELETE FROM contatos WHERE contato =\'"+contato+"\' and id=\'"+Id+"\'");
				Resul=true;
			}
			catch(SQLException E)
			{
				System.out.println("Erro ao deletar contato");
				System.out.println(E.getMessage());
			}
		}
		//else
		//	System.out.print("nao existe usuario na lista");
		//else
		//	System.out.print("exist user ?");
		
		return Resul;
	}
	
	public boolean ExistContactUser(int Id, int contato)
	{	//this func verify if exist contato user in the list of other user
		
		boolean Resul=false;
		String Ident = "_"+Id;
			
		try
		{
			Resultado = comando.executeQuery("SELECT count(id) as E FROM contatos WHERE contato =\'"+contato+"\' and id =\'"+Id+"\'");
			////Resultado = comando.executeQuery("SELECT count(id) as E FROM contatos WHERE contato =\'"+contato+"\'");
			
		}
		catch(SQLException E)
		{
			System.out.println("Erro verificar contato em lista 1");
			System.out.println(E.getMessage());
		}
		
		try
		{
			Resultado.first();
		}
		catch(SQLException E)
		{
			System.out.println("Erro exist user first");
		}
		
		
		try
		{
			Resul = Resultado.getInt("E") != 0;
		}
		catch (SQLException E)
		{
			System.out.println("Erro em contato user");
		}
				
		return Resul;
	}
	
	public String ReturnContactList(int Ident)
	{
		String contatos =  "contatoList" ;
		String Token = "###";
		int IdUser=0;
		
		BancoDados THIS = new BancoDados(Host,Port);
		////Na hora do logout ele nao atualizava a lista dos contatos por causa desse if
		//if(!ReturnUserIp(Ident).equals("0")){
		try
		{
			this.Resultado = comando.executeQuery("SELECT * FROM contatos WHERE id= \'"+Ident+"\'");
		}
		catch(SQLException E)
		{
			System.err.println("Erro ao pesquisar lista de usuarios");
			System.err.println(E.getMessage());
		}
		try
		{
			if(!this.Resultado.wasNull()) // if exist contato (return != null)
			this.Resultado.first();
		}
		catch(SQLException E)
		{
			System.err.println("Erro indexando lista uauario");
			System.err.println(E.getMessage());
		}

		try
		{
				//System.out.println("teste0");
			if(this.Resultado.isFirst())
			while(!this.Resultado.isAfterLast())
			{
				//System.out.println("teste1");
				IdUser = this.Resultado.getInt("contato");
				//System.out.println(contatos);
				contatos = contatos+Token+IdUser+Token+THIS.ReturnUserLogin(IdUser)+Token+THIS.ReturnUserIp(IdUser)+Token+THIS.ReturnUserPort(IdUser);
				////contatos = contatos+Token+IdUser+Token+THIS.ReturnUserLogin(IdUser)+Token+THIS.ReturnUserIp(IdUser);
				this.Resultado.next();
			}
		}
		catch(SQLException E)
		{
			System.err.println("Erro ao FORMAR lista de usuarios");
			System.err.println(E.getMessage());
		}
		//}

		return contatos;
	}
	
	public String ReturnUsers(int option)
	{
	////Acrescentada a portaa
		String usuariosOnline =  "Onlineusuarios" ,IpUser ,LoginUser, portaUser;
		String Token = "###";
		int IdUser=0;
		
		try
		{
			this.Resultado = comando.executeQuery("SELECT login,ip,id,porta FROM usuarios");
		}
		catch(SQLException E)
		{
			System.err.println("Erro ao pesquisar lista de usuarios");
			System.err.println(E.getMessage());
		}
		try
		{
			if(!this.Resultado.wasNull()) // if exist contato (return != null)
			this.Resultado.first();
		}
		catch(SQLException E)
		{
			System.err.println("Erro indexando lista uauario");
			System.err.println(E.getMessage());
		}
				
		try
		{
			if(this.Resultado.isFirst())
			while(!this.Resultado.isAfterLast())
			{
				IpUser = this.Resultado.getString("ip");


				if(! IpUser.equals("0"))
				{
					IdUser =  this.Resultado.getInt("id");
					LoginUser = this.Resultado.getString("login");
					////Acrescentada a portaa
					portaUser = this.Resultado.getString("porta");
					usuariosOnline = usuariosOnline+Token+IdUser+Token+LoginUser+Token+IpUser+Token+portaUser;
				}
					else
				if(option==0) // option == zero (true), return all usuarios (online and offline)
				{
					IdUser =  this.Resultado.getInt("id");
					LoginUser = this.Resultado.getString("login");
					usuariosOnline = usuariosOnline+Token+IdUser+Token+LoginUser+Token+IpUser+Token+"0";
				}
				
				this.Resultado.next();
			}
		}
		catch(SQLException E)
		{
			System.err.println("Erro ao FORMAR lista de usuarios");
			System.err.println(E.getMessage());		
		}
			
		return usuariosOnline;
	}
	
}	


